(use-package paredit
  :ensure t
  :config
  (autoload 'enable-paredit-mode "paredit" "Turn on pseudo-structural editing of Lisp code." t)
  :hook
  (emacs-lisp-mode . enable-paredit-mode)
  (eval-expression-minibuffer-setup enable-paredit-mode)
  (ielm-mode . enable-paredit-mode)
  (lisp-mode . enable-paredit-mode)
  (lisp-interaction-mode . enable-paredit-mode)
  (scheme-mode . enable-paredit-mode))

(use-package highlight-parentheses
  :ensure t
  :config
  (global-highlight-parentheses-mode t))

(use-package rainbow-delimiters
  :ensure t
  :config
  (add-hook 'prog-mode-hook #'rainbow-delimiters-mode))

;; Hack to show only files known to git inside dired; needs the
;; `git-find' shell script shim (taken from :open https://r0tty.org/git/dotfiles/emacs/tree/.emacs.d/config/development.el)
(defun git-dired (dir)
  (interactive (list (read-directory-name "Find files in directory: " nil "" t)))
  (let ((find-program "git-find"))
    (find-dired dir "")))

;; python
;; (defun my-shell-mode-hook ()
;;   (add-hook
;;    'comint-output-filter-functions
;;    'python-pdbtrack-comint-output-filter-function t))
;; (add-hook 'shell-mode-hook 'my-shell-mode-hook)

;; enable flyspell checks for comments in code
(add-hook 'prog-mode-hook #'flyspell-prog-mode)

(use-package lsp-mode
  :ensure t
  :hook
  (python-mode . lsp-deferred)
  (rust-mode . lsp-deferred)
  (toml-mode . lsp-deferred))
